  LIST P=16F628A
  #include p16f628A.inc
  #include globals.inc
;------------------------------------------------------------------------------- 
 extern COUNT
;-------------------------------------------------------------------------------

;-------------------------------------------------------------------------------
BANK0 UDATA
;-------------------------------------------------------------------------------
;..... your variables here ....
LedState 	RES	1
LedTimer    RES 1
timersec 	RES 1

	Global 	LedTimer,LedState,timersec,counter
;-------------------------------------------------------------------------------
JUMPTAB0	CODE
;-------------------------------------------------------------------------------
LEDManager
 GLOBAL LEDManager
		movlw 	.10	            
		;movlw	.1       
		BANKSEL LedTimer		;Loading timer value
		movwf 	LedTimer		;to 30sec
	    movlw 	high LEDManager
		movwf	PCLATH
		
		;btfss INTCON,T0IF
		;goto	exit
		
		movf    LedState,w
		addwf   PCL,f	
        goto    led_state_1
	    goto    led_state_2 

;-------------------------------------------------------------------------------
PROG0	CODE
;-------------------------------------------------------------------------------


;...... your state machine here ......
;led_state_1 begin
led_state_1	
				;call 	counter
	            movf    COUNT
				 ; Now you can check the Z flag:
				btfsc  STATUS,Z
				goto   next  ; Counter is zero...
				nop          ; Counter is non-zero...
				bsf  	PORTB, POWERLED ;Turn on LED
			    ;wait if there's interrupt				
				;btfss	STATUS,Z
				
				
	next		incf     LedState,1		 ;increase the state, for the next state
				
				return
;led_state_1 end
;-------------------------------------------------------------------------------
;led_state_2 begin		
led_state_2
				movf    COUNT
				 ; Now you can check the Z flag:
				btfsc  STATUS,Z
				goto   next2  ; Counter is zero...
				nop          ; Counter is non-zero.
                
				bcf		PORTB, POWERLED ;Turn off LED
                ;btfss	STATUS,Z
				;goto	exit
				
				;jump to previous state if there's interrupt
				
next2			decf    LedState,1		;increase the state, for the next state          
				return
;led_state_2 end

;-------------------------------------------------------------------------------
;--------------- Called in Initialisation ----------------------
initState
	Global 	initState
	movlw 	0x00
	BANKSEL	LedState		;Initialising
	movwf 	LedState		;State Value to '0'

	movlw 	.10	
	;movlw	.1				;test for 1s
	BANKSEL LedTimer		;Loading seconds timer
	movwf 	LedTimer		;to 10 
	return
;--------------------------------------------------------
;---------------------- Called in States ------------------
;counter	
;		Global	counter	
;		BANKSEL LedTimer		
;		movf 	LedTimer,w		;Checking timervalue
;		btfsc 	STATUS,Z		;reaches 0 or not?
;		return					;Yes-Return
;		decf 	LedTimer,f		;No-decrement value
;		return 					;and return

;------------------Call in Timer Module --------------------
counter
	Global 	counter			;Decrementing Sec's  
	BANKSEL LedTimer		;timer value
    movf 	LedTimer,w		;for every 10 counts
    btfss 	STATUS,Z
    decf 	LedTimer,f
   
	return
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;test
;------------------Call in Timer Module --------------------
;counter
;	Global 	counter			;Decrementing Sec's  
;	BANKSEL LedTimer		;timer value
;    movlw 	.10				;for every 10 counts
;    movwf	LedTimer
;check decfsz LedTimer
;      goto	 check
   
;	return
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	
 exit
 return ;LEDManager
 
		END
